diff -urN Original_4.4.4_r1/frameworks/base/services/input/InputDispatcher.cpp AndroidSource/frameworks/base/services/input/InputDispatcher.cpp
--- Original_4.4.4_r1/frameworks/base/services/input/InputDispatcher.cpp	2016-01-29 15:12:34.459488000 +0900
+++ AndroidSource/frameworks/base/services/input/InputDispatcher.cpp	2015-08-04 09:56:42.000000000 +0900
@@ -1989,8 +1989,12 @@
             }
 
             // Publish the motion event.
+
+            //ALOGD("InputDispatcher-startdispatch: %d", motionEntry->sourceDevice);
+
             status = connection->inputPublisher.publishMotionEvent(dispatchEntry->seq,
                     motionEntry->deviceId, motionEntry->source,
+                    //motionEntry->sourceDevice,
                     dispatchEntry->resolvedAction, dispatchEntry->resolvedFlags,
                     motionEntry->edgeFlags, motionEntry->metaState, motionEntry->buttonState,
                     xOffset, yOffset,
@@ -2307,6 +2311,7 @@
             originalMotionEntry->deviceId,
             originalMotionEntry->source,
             originalMotionEntry->policyFlags,
+            //originalMotionEntry->sourceDevice,
             action,
             originalMotionEntry->flags,
             originalMotionEntry->metaState,
@@ -2432,6 +2437,7 @@
             "action=0x%x, flags=0x%x, metaState=0x%x, buttonState=0x%x, edgeFlags=0x%x, "
             "xPrecision=%f, yPrecision=%f, downTime=%lld",
             args->eventTime, args->deviceId, args->source, args->policyFlags,
+            //args->sourceDevice,
             args->action, args->flags, args->metaState, args->buttonState,
             args->edgeFlags, args->xPrecision, args->yPrecision, args->downTime);
     for (uint32_t i = 0; i < args->pointerCount; i++) {
@@ -2468,7 +2474,12 @@
             mLock.unlock();
 
             MotionEvent event;
-            event.initialize(args->deviceId, args->source, args->action, args->flags,
+
+            //ALOGD("inputDispatcher-notifymotion: %d", args->sourceDevice);
+
+            event.initialize(args->deviceId, args->source,
+            		//args->sourceDevice,
+            		args->action, args->flags,
                     args->edgeFlags, args->metaState, args->buttonState, 0, 0,
                     args->xPrecision, args->yPrecision,
                     args->downTime, args->eventTime,
@@ -2485,6 +2496,7 @@
         // Just enqueue a new motion event.
         MotionEntry* newEntry = new MotionEntry(args->eventTime,
                 args->deviceId, args->source, policyFlags,
+                //args->sourceDevice,
                 args->action, args->flags, args->metaState, args->buttonState,
                 args->edgeFlags, args->xPrecision, args->yPrecision, args->downTime,
                 args->displayId,
@@ -2605,6 +2617,7 @@
         const PointerCoords* samplePointerCoords = motionEvent->getSamplePointerCoords();
         firstInjectedEntry = new MotionEntry(*sampleEventTimes,
                 motionEvent->getDeviceId(), motionEvent->getSource(), policyFlags,
+                //motionEvent->getSourceDevice(),
                 action, motionEvent->getFlags(),
                 motionEvent->getMetaState(), motionEvent->getButtonState(),
                 motionEvent->getEdgeFlags(),
@@ -2617,6 +2630,7 @@
             samplePointerCoords += pointerCount;
             MotionEntry* nextInjectedEntry = new MotionEntry(*sampleEventTimes,
                     motionEvent->getDeviceId(), motionEvent->getSource(), policyFlags,
+                    //motionEvent->getSourceDevice(),
                     action, motionEvent->getFlags(),
                     motionEvent->getMetaState(), motionEvent->getButtonState(),
                     motionEvent->getEdgeFlags(),
@@ -3894,14 +3908,18 @@
 // --- InputDispatcher::MotionEntry ---
 
 InputDispatcher::MotionEntry::MotionEntry(nsecs_t eventTime,
-        int32_t deviceId, uint32_t source, uint32_t policyFlags, int32_t action, int32_t flags,
+        int32_t deviceId, uint32_t source, uint32_t policyFlags,
+        //int32_t sourceDevice,
+        int32_t action, int32_t flags,
         int32_t metaState, int32_t buttonState,
         int32_t edgeFlags, float xPrecision, float yPrecision,
         nsecs_t downTime, int32_t displayId, uint32_t pointerCount,
         const PointerProperties* pointerProperties, const PointerCoords* pointerCoords) :
         EventEntry(TYPE_MOTION, eventTime, policyFlags),
         eventTime(eventTime),
-        deviceId(deviceId), source(source), action(action), flags(flags),
+        deviceId(deviceId), source(source),
+        //sourceDevice(sourceDevice),
+        action(action), flags(flags),
         metaState(metaState), buttonState(buttonState), edgeFlags(edgeFlags),
         xPrecision(xPrecision), yPrecision(yPrecision),
         downTime(downTime), displayId(displayId), pointerCount(pointerCount) {
@@ -4195,6 +4213,7 @@
         if (shouldCancelMotion(memento, options)) {
             outEvents.push(new MotionEntry(currentTime,
                     memento.deviceId, memento.source, memento.policyFlags,
+                    //memento.sourceDevice,
                     memento.hovering
                             ? AMOTION_EVENT_ACTION_HOVER_EXIT
                             : AMOTION_EVENT_ACTION_CANCEL,
diff -urN Original_4.4.4_r1/frameworks/base/services/input/InputDispatcher.h AndroidSource/frameworks/base/services/input/InputDispatcher.h
--- Original_4.4.4_r1/frameworks/base/services/input/InputDispatcher.h	2016-01-29 15:12:34.459488000 +0900
+++ AndroidSource/frameworks/base/services/input/InputDispatcher.h	2015-08-04 09:57:07.000000000 +0900
@@ -506,6 +506,7 @@
         nsecs_t eventTime;
         int32_t deviceId;
         uint32_t source;
+        //int32_t sourceDevice;
         int32_t action;
         int32_t flags;
         int32_t metaState;
@@ -521,6 +522,7 @@
 
         MotionEntry(nsecs_t eventTime,
                 int32_t deviceId, uint32_t source, uint32_t policyFlags,
+                //int32_t sourceDevice,
                 int32_t action, int32_t flags,
                 int32_t metaState, int32_t buttonState, int32_t edgeFlags,
                 float xPrecision, float yPrecision,
@@ -754,6 +756,7 @@
         struct MotionMemento {
             int32_t deviceId;
             uint32_t source;
+            //int32_t sourceDevice;
             int32_t flags;
             float xPrecision;
             float yPrecision;
diff -urN Original_4.4.4_r1/frameworks/base/services/input/InputListener.cpp AndroidSource/frameworks/base/services/input/InputListener.cpp
--- Original_4.4.4_r1/frameworks/base/services/input/InputListener.cpp	2016-01-29 15:12:34.459488000 +0900
+++ AndroidSource/frameworks/base/services/input/InputListener.cpp	2015-08-04 10:05:40.000000000 +0900
@@ -68,14 +68,17 @@
 
 NotifyMotionArgs::NotifyMotionArgs(nsecs_t eventTime, int32_t deviceId, uint32_t source,
         uint32_t policyFlags,
+        //int32_t sourceDevice,
         int32_t action, int32_t flags, int32_t metaState, int32_t buttonState,
         int32_t edgeFlags, int32_t displayId, uint32_t pointerCount,
         const PointerProperties* pointerProperties, const PointerCoords* pointerCoords,
         float xPrecision, float yPrecision, nsecs_t downTime) :
         eventTime(eventTime), deviceId(deviceId), source(source), policyFlags(policyFlags),
+        //sourceDevice(sourceDevice),
         action(action), flags(flags), metaState(metaState), buttonState(buttonState),
         edgeFlags(edgeFlags), displayId(displayId), pointerCount(pointerCount),
         xPrecision(xPrecision), yPrecision(yPrecision), downTime(downTime) {
+	//ALOGD("inputListener-NotifyMotionArgs: %d", sourceDevice);
     for (uint32_t i = 0; i < pointerCount; i++) {
         this->pointerProperties[i].copyFrom(pointerProperties[i]);
         this->pointerCoords[i].copyFrom(pointerCoords[i]);
@@ -85,11 +88,13 @@
 NotifyMotionArgs::NotifyMotionArgs(const NotifyMotionArgs& other) :
         eventTime(other.eventTime), deviceId(other.deviceId), source(other.source),
         policyFlags(other.policyFlags),
+        //sourceDevice(other.sourceDevice),
         action(other.action), flags(other.flags),
         metaState(other.metaState), buttonState(other.buttonState),
         edgeFlags(other.edgeFlags), displayId(other.displayId),
         pointerCount(other.pointerCount),
         xPrecision(other.xPrecision), yPrecision(other.yPrecision), downTime(other.downTime) {
+	//ALOGD("inputListener-OtherNotifyMotionArgs: %d", other.sourceDevice);
     for (uint32_t i = 0; i < pointerCount; i++) {
         pointerProperties[i].copyFrom(other.pointerProperties[i]);
         pointerCoords[i].copyFrom(other.pointerCoords[i]);
diff -urN Original_4.4.4_r1/frameworks/base/services/input/InputListener.h AndroidSource/frameworks/base/services/input/InputListener.h
--- Original_4.4.4_r1/frameworks/base/services/input/InputListener.h	2016-01-29 15:12:34.459488000 +0900
+++ AndroidSource/frameworks/base/services/input/InputListener.h	2015-08-04 10:05:06.000000000 +0900
@@ -83,6 +83,7 @@
     int32_t deviceId;
     uint32_t source;
     uint32_t policyFlags;
+    //int32_t sourceDevice;
     int32_t action;
     int32_t flags;
     int32_t metaState;
@@ -99,7 +100,8 @@
     inline NotifyMotionArgs() { }
 
     NotifyMotionArgs(nsecs_t eventTime, int32_t deviceId, uint32_t source, uint32_t policyFlags,
-            int32_t action, int32_t flags, int32_t metaState, int32_t buttonState,
+            //int32_t sourceDevice,
+    		int32_t action, int32_t flags, int32_t metaState, int32_t buttonState,
             int32_t edgeFlags, int32_t displayId, uint32_t pointerCount,
             const PointerProperties* pointerProperties, const PointerCoords* pointerCoords,
             float xPrecision, float yPrecision, nsecs_t downTime);
diff -urN Original_4.4.4_r1/frameworks/base/services/input/InputReader.cpp AndroidSource/frameworks/base/services/input/InputReader.cpp
--- Original_4.4.4_r1/frameworks/base/services/input/InputReader.cpp	2016-01-29 15:12:34.459488000 +0900
+++ AndroidSource/frameworks/base/services/input/InputReader.cpp	2015-08-04 10:07:57.000000000 +0900
@@ -2509,6 +2509,7 @@
         }
 
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                 motionEventAction, 0, metaState, currentButtonState, 0,
                 displayId, 1, &pointerProperties, &pointerCoords,
                 mXPrecision, mYPrecision, downTime);
@@ -2518,6 +2519,7 @@
         if (motionEventAction == AMOTION_EVENT_ACTION_UP
                 && mPointerController != NULL) {
             NotifyMotionArgs hoverArgs(when, getDeviceId(), mSource, policyFlags,
+            		//0,
                     AMOTION_EVENT_ACTION_HOVER_MOVE, 0,
                     metaState, currentButtonState, AMOTION_EVENT_EDGE_FLAG_NONE,
                     displayId, 1, &pointerProperties, &pointerCoords,
@@ -2531,6 +2533,7 @@
             pointerCoords.setAxisValue(AMOTION_EVENT_AXIS_HSCROLL, hscroll);
 
             NotifyMotionArgs scrollArgs(when, getDeviceId(), mSource, policyFlags,
+            		//0,
                     AMOTION_EVENT_ACTION_SCROLL, 0, metaState, currentButtonState,
                     AMOTION_EVENT_EDGE_FLAG_NONE,
                     displayId, 1, &pointerProperties, &pointerCoords,
@@ -4550,6 +4553,7 @@
         pointerCoords.setAxisValue(AMOTION_EVENT_AXIS_Y, y);
 
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                 AMOTION_EVENT_ACTION_HOVER_MOVE, 0,
                 metaState, buttonState, AMOTION_EVENT_EDGE_FLAG_NONE,
                 mViewport.displayId, 1, &pointerProperties, &pointerCoords,
@@ -5472,6 +5476,7 @@
 
         // Send up.
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                  AMOTION_EVENT_ACTION_UP, 0, metaState, mLastButtonState, 0,
                  mViewport.displayId,
                  1, &mPointerSimple.lastProperties, &mPointerSimple.lastCoords,
@@ -5485,6 +5490,7 @@
 
         // Send hover exit.
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                 AMOTION_EVENT_ACTION_HOVER_EXIT, 0, metaState, mLastButtonState, 0,
                 mViewport.displayId,
                 1, &mPointerSimple.lastProperties, &mPointerSimple.lastCoords,
@@ -5500,6 +5506,7 @@
 
             // Send down.
             NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+            		//0,
                     AMOTION_EVENT_ACTION_DOWN, 0, metaState, mCurrentButtonState, 0,
                     mViewport.displayId,
                     1, &mPointerSimple.currentProperties, &mPointerSimple.currentCoords,
@@ -5510,6 +5517,7 @@
 
         // Send move.
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                 AMOTION_EVENT_ACTION_MOVE, 0, metaState, mCurrentButtonState, 0,
                 mViewport.displayId,
                 1, &mPointerSimple.currentProperties, &mPointerSimple.currentCoords,
@@ -5524,6 +5532,7 @@
 
             // Send hover enter.
             NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+            		//0,
                     AMOTION_EVENT_ACTION_HOVER_ENTER, 0, metaState, mCurrentButtonState, 0,
                     mViewport.displayId,
                     1, &mPointerSimple.currentProperties, &mPointerSimple.currentCoords,
@@ -5534,6 +5543,7 @@
 
         // Send hover move.
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                 AMOTION_EVENT_ACTION_HOVER_MOVE, 0, metaState, mCurrentButtonState, 0,
                 mViewport.displayId,
                 1, &mPointerSimple.currentProperties, &mPointerSimple.currentCoords,
@@ -5555,6 +5565,7 @@
         pointerCoords.setAxisValue(AMOTION_EVENT_AXIS_HSCROLL, hscroll);
 
         NotifyMotionArgs args(when, getDeviceId(), mSource, policyFlags,
+        		//0,
                 AMOTION_EVENT_ACTION_SCROLL, 0, metaState, mCurrentButtonState, 0,
                 mViewport.displayId,
                 1, &mPointerSimple.currentProperties, &pointerCoords,
@@ -5617,6 +5628,7 @@
     }
 
     NotifyMotionArgs args(when, getDeviceId(), source, policyFlags,
+    		//0,
             action, flags, metaState, buttonState, edgeFlags,
             mViewport.displayId, pointerCount, pointerProperties, pointerCoords,
             xPrecision, yPrecision, downTime);
@@ -6460,6 +6472,7 @@
     uint32_t policyFlags = 0;
 
     NotifyMotionArgs args(when, getDeviceId(), AINPUT_SOURCE_JOYSTICK, policyFlags,
+    		//0,
             AMOTION_EVENT_ACTION_MOVE, 0, metaState, buttonState, AMOTION_EVENT_EDGE_FLAG_NONE,
             ADISPLAY_ID_NONE, 1, &pointerProperties, &pointerCoords, 0, 0, 0);
     getListener()->notifyMotion(&args);
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/devicemanager/ReturnThread.java AndroidSource/frameworks/base/services/java/com/android/server/devicemanager/ReturnThread.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/devicemanager/ReturnThread.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/devicemanager/ReturnThread.java	2016-01-12 20:47:27.000000000 +0900
@@ -0,0 +1,57 @@
+
+package com.android.server.devicemanager;
+
+import android.service.devicemanager.Device;
+import android.service.devicemanager.DeviceList;
+import android.util.Log;
+
+import java.io.DataInputStream;
+import java.io.IOException;
+import java.io.InputStream;
+import java.net.InetAddress;
+import java.net.Socket;
+
+public class ReturnThread extends Thread {
+    public static final int PORT = 9050;
+
+    private Socket socket;
+
+    public ReturnThread(Socket socket) {
+        this.socket = socket;
+    }
+
+    public void run() {
+        try {
+            InputStream in = socket.getInputStream();
+            DataInputStream dis = new DataInputStream(in);
+            String return_msg = dis.readUTF();
+
+            String[] temp2 = return_msg.split("_");
+            String macAddr = temp2[0];
+            String ipaddress = temp2[1];
+            String idlecpu = temp2[2];
+            String deviceName = temp2[3];
+            int isCollaboroidOn = Integer.parseInt(temp2[4]);
+            int isTaskExecutor = Integer.parseInt(temp2[5]);
+
+            Log.i("ReturnThread", "device: " + macAddr + "  return ip: " + ipaddress
+                    + "  return cpu usage: " + idlecpu);
+            
+            Device p = new Device(ipaddress, idlecpu, deviceName, isCollaboroidOn, isTaskExecutor);
+            Log.i("ReturnThread", "device name: " + macAddr + " / peer: " + p.toString());
+            
+            if (ipaddress.equals(RecommenderUDPReceiver.getIpaddress())){
+                Log.i("ReturnThread", "Return from own device: " + ipaddress + ", " + InetAddress.getLocalHost().getHostAddress());
+            }
+            else{
+                DeviceList.getDevices().put(macAddr, p);
+                Log.i("ReturnThread", "Added to Peer list " + ipaddress + ", " + RecommenderUDPReceiver.getIpaddress());
+            }
+            
+            socket.close();
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+    }
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/JobManager.java AndroidSource/frameworks/base/services/java/com/android/server/distribute/JobManager.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/JobManager.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/distribute/JobManager.java	2015-01-27 17:21:21.000000000 +0900
@@ -0,0 +1,291 @@
+package com.android.server.distribute;
+
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.Socket;
+import java.util.ArrayList;
+import java.util.concurrent.atomic.AtomicInteger;
+
+import android.util.Log;
+
+public class JobManager 
+{
+	private static final String TAG = "JobManager";
+	private static final int DISTRIBUTED_COMPUTING_PORT = 55556;
+	
+	int node_num = 0, task_num = 0, total_task_num = 0;
+	
+	ArrayList<String> nodes;
+	//private final IRecommender mService;
+	
+	// for node performance
+	long node_info[][];
+	int node_perf_ratio[];
+	
+	long total_runtime = 0;
+	boolean isrunning = false;
+
+	int task_length, taskinfo_length;
+
+	AtomicInteger current_task = new AtomicInteger(0);
+	
+	ArrayList<TaskRequest> tasks;
+	
+	public JobManager(ArrayList<String> ip_list)
+	{
+		//mService = IRecommender.Stub.asInterface(ServiceManager.getService("recommender"));
+		
+		//nodes = mService.getPeerList();
+		nodes = ip_list;
+		node_num = nodes.size();
+		
+		node_info = new long[node_num][2]; // [][0]=task_count, [][1]=runtime
+		node_perf_ratio = new int[node_num];
+		
+		tasks = new ArrayList<TaskRequest>();
+		
+		Log.d(TAG, nodes.toString());
+		Log.d(TAG, "node_num: " + node_num);
+	}
+	
+	public void submitTask(TaskRequest task)
+	{
+		tasks.add(task);
+		task_num++;
+		Log.d(TAG, tasks.toString());
+	}
+	
+	/*public <T> Task submitTask(T t)
+	{
+		Task task = (Task)t;
+		
+		return task;
+	}*/
+	
+	public Object[] executeJob()
+	{
+		Thread node_thread[] = new Thread[node_num];
+		final long[][] job_info = new long[node_num][2];
+		
+		long begin, terminate;
+		
+		final Object[] results = new Object[task_num];
+		
+		// calculate node performance
+		if(node_perf_ratio[0] == 0)
+			executeTestcode();
+		else
+			for(int i=1; i<node_num; i++)
+				node_perf_ratio[i] = (int) Math.round((double)((float)node_info[i][1]/(float)node_info[i][0]) / ((float)node_info[0][1]/(float)node_info[0][0]));
+		
+		begin = System.currentTimeMillis();
+		try
+		{
+			// create thread for each node
+			for(int i = 0; i < node_num; i++)
+			{
+				final int num = i;
+				node_thread[i] = new Thread(new Runnable()
+				{
+					public void run()
+					{
+						long start=0, end=0;
+						job_info[num][0] = 0;
+						job_info[num][1] = 0;
+						
+						if(nodes.get(num).equals("localhost"))
+						{
+							int running_task = 0;// current_task.getAndIncrement();
+							
+							while((running_task=current_task.getAndIncrement()) < task_num)
+							{
+								if((task_num-running_task) < node_perf_ratio[num])
+								{
+									Log.d(TAG, "remain task: " + (task_num-running_task));
+									task_num++;
+									tasks.add(tasks.get(running_task));				
+									break;
+								}
+							
+								start = System.currentTimeMillis();
+	
+								//tasks.get(running_task).setValue(tasks.get(running_task).getTask().execute());
+						
+								end = System.currentTimeMillis();		
+								
+								job_info[num][0]++;
+								job_info[num][1]+=(end-start);
+							}
+						}
+						else
+						{
+							try
+							{
+								Socket node = new Socket(nodes.get(num), DISTRIBUTED_COMPUTING_PORT);
+
+								ObjectOutputStream oos = new ObjectOutputStream(node.getOutputStream());
+								ObjectInputStream ois = new ObjectInputStream(node.getInputStream());
+
+								int running_task=0;
+								
+								while((running_task=current_task.getAndIncrement()) < task_num)
+								{
+									Log.d(TAG, "running_task: " + running_task);
+									Log.d(TAG, "task_num: " + task_num);
+									
+									if((task_num-running_task) < node_perf_ratio[num])
+									{
+										Log.d(TAG, "remain task: " + (task_num-running_task));
+										task_num++;
+										tasks.add(tasks.get(running_task));				
+										break;
+									}
+									
+									start = System.currentTimeMillis();
+	
+									oos.writeObject(tasks.get(running_task));
+									//oos.flush();
+
+									//tasks.get(running_task).setValue(ois.readObject());
+									//reois.readObject()
+									
+									//results.set(running_task, ois.readObject());
+									results[running_task] = ois.readObject();
+									
+									end = System.currentTimeMillis();
+									
+									job_info[num][0]++;
+									job_info[num][1]+=(end-start);
+								}
+								oos.writeObject(new TaskRequest("BYE", null));
+								node.close();
+							}
+							catch (Exception e)
+							{
+								// TODO Auto-generated catch block
+								Log.e(TAG, "ExecuteJob exception:");
+								e.printStackTrace();
+							}
+						}
+					}
+				});
+				node_thread[i].start();
+			}
+			for(int i = 0; i < node_num; i++)
+				node_thread[i].join();
+		}
+		catch (Exception e)
+		{
+			e.printStackTrace();
+		}
+		
+		terminate = System.currentTimeMillis();
+		tasks.clear();
+		current_task.set(0);
+		collect_info(job_info);
+		total_runtime += (terminate - begin);
+		isrunning = false;
+		total_task_num += task_num;
+		task_num = 0;
+		
+		return results;
+	}
+	
+	public void executeTestcode()
+	{
+		final ArrayList<String> temp_list = new ArrayList<String>();
+		final ArrayList<Long> testcode_runtime = new ArrayList<Long>();
+		
+		final ArrayList<Object> paras = new ArrayList<Object>();
+		paras.add(10);
+		paras.add(100000);
+		
+		Thread node_thread[] = new Thread[node_num];
+		
+		try
+		{
+			// create thread for each node
+			for(int i=0; i<node_num; i++)
+			{
+				final int num = i;
+				node_thread[i] = new Thread(new Runnable()
+				{
+					public void run()
+					{
+						try
+						{
+							long start, end;
+							Socket node = new Socket(nodes.get(num), DISTRIBUTED_COMPUTING_PORT);
+
+							ObjectOutputStream oos = new ObjectOutputStream(node.getOutputStream());
+							ObjectInputStream ois = new ObjectInputStream(node.getInputStream());
+
+							start = System.currentTimeMillis();
+
+							oos.writeObject(new TaskRequest("SUM", paras));
+							ois.readObject();
+							
+							end = System.currentTimeMillis();
+
+							temp_list.add(nodes.get(num));
+							testcode_runtime.add(end-start);
+							
+							oos.writeObject(new TaskRequest("BYE", null));
+							node.close();
+						}
+						catch (Exception e)
+						{
+							// TODO Auto-generated catch block
+							Log.e(TAG, "TestCode exception:");
+							e.printStackTrace();
+						}											
+					}
+				});
+				node_thread[i].start();
+			}		
+			for(int i=0; i<node_num; i++)
+				node_thread[i].join();		
+			Log.d(TAG, "all finish!" + node_num);
+		}
+		catch(Exception e)
+		{
+			e.printStackTrace();
+		}
+		
+		nodes = temp_list;
+		
+		for(int i=0; i<node_num; i++)
+    		node_perf_ratio[i] = (int) Math.round((double)testcode_runtime.get(i) / testcode_runtime.get(0));
+	}
+	
+	public void collect_info(long[][] job_info)
+	{
+		for(int i = 0; i < node_num; i++)
+		{
+			node_info[i][0] += job_info[i][0];
+			node_info[i][1] += job_info[i][1];
+		}
+	}
+
+	public void print_info()
+	{
+		System.out
+				.println(" task count | % of all tasks | task time sum | time per task | job server");
+
+		for(int i = 0; i < node_num; i++)
+			System.out.printf(
+					"%11d |        %7.2f |     %9.3f |  %12.6f | %s\n",
+					node_info[i][0],
+					(((float) node_info[i][0] / (float) total_task_num)) * 100,
+					(float) node_info[i][1] / 1000,
+					((float) node_info[i][1] / (float) node_info[i][0]) / 1000,
+					nodes.get(i));
+
+		System.out.println("\ntotal runtime is " + total_runtime / 1000 + "."
+				+ total_runtime % 1000 + "sec");
+
+		System.out.println("task_length : " + task_length + "\ntaskinfo_length : "
+				+ taskinfo_length);
+
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/NodeManager.java AndroidSource/frameworks/base/services/java/com/android/server/distribute/NodeManager.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/NodeManager.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/distribute/NodeManager.java	2016-01-12 09:25:30.000000000 +0900
@@ -0,0 +1,23 @@
+package com.android.server.distribute;
+
+import android.os.ServiceManager;
+import android.service.devicemanager.IDeviceManager;
+
+public class NodeManager 
+{
+	private final IDeviceManager mService;
+	
+	public NodeManager()
+	{
+		mService = IDeviceManager.Stub.asInterface(ServiceManager.getService("devicemanager"));
+	}
+	
+	/*public ArrayList<String> getNodes()
+	{
+		List<Peer> peers = mService.getPeerList();
+		
+		ArrayList<String> nodes = new ArrayList<String>();
+		
+		nodes.addAll(peers.)
+	}*/
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/Sum.java AndroidSource/frameworks/base/services/java/com/android/server/distribute/Sum.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/Sum.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/distribute/Sum.java	2015-01-27 14:55:53.000000000 +0900
@@ -0,0 +1,28 @@
+package com.android.server.distribute;
+
+public class Sum implements Task<Integer>
+{
+	private final int min, max;
+	
+	public Sum(int min, int max)
+	{
+		this.min = min;
+		this.max = max;
+	}
+
+	public Integer execute()
+	{
+		return sum(min, max);
+	}
+	
+	public static int sum(int min, int max)
+	{
+		int i=0;
+		int result = 0;
+		
+		for(i=min; i<max; i++)
+			result += i;
+		
+		return result;
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/TaskExecutor.java AndroidSource/frameworks/base/services/java/com/android/server/distribute/TaskExecutor.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/TaskExecutor.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/distribute/TaskExecutor.java	2015-01-27 21:54:48.000000000 +0900
@@ -0,0 +1,137 @@
+package com.android.server.distribute;
+
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.ServerSocket;
+import java.net.Socket;
+
+import android.util.Log;
+
+public class TaskExecutor extends Thread
+{
+	private static final String TAG = "TaskExecutor";
+	private static final int DISTRIBUTED_COMPUTING_PORT = 55556;
+	
+	long execution_time = 0;
+	
+	ServerSocket serverSocket;
+	Socket socket;
+	
+	ObjectOutputStream outToClient;
+	ObjectInputStream inFromClient;
+	
+	TaskRequest task;
+	Object result;
+	
+	private static boolean isConnected = false;
+	
+	public void terminate()
+	{
+		try
+		{
+			outToClient.close();
+			inFromClient.close();
+			socket.close();
+		}
+		catch(IOException e)
+		{
+			e.printStackTrace();
+		}
+	}
+	
+	//Socket client;
+	@Override
+	public void run()
+	{
+		try
+		{
+			socket = null;
+			serverSocket = new ServerSocket(DISTRIBUTED_COMPUTING_PORT);
+			
+			
+			
+			long start, end;
+			
+			while (!Thread.currentThread().isInterrupted())
+			{
+				Log.d(TAG, "TaskExecutor successfully started!");
+				socket = serverSocket.accept();
+				isConnected = true;
+				Log.d(TAG, socket.getInetAddress() + "connected.");
+				
+				outToClient = new ObjectOutputStream(socket.getOutputStream());
+				inFromClient = new ObjectInputStream(socket.getInputStream());
+				
+				while(isConnected)
+				{
+					task = (TaskRequest)inFromClient.readObject();
+					Log.d(TAG, "Request!!!!");
+					
+					start = System.currentTimeMillis();
+					
+					result = handleTask(task);
+					Log.d(TAG, "result: " + result);
+					
+					end = System.currentTimeMillis();
+					
+					if(result != null)
+						outToClient.writeObject(result);
+					//outToClient.reset();
+					
+					execution_time += (end-start);
+					
+					//outToClient.writeObject(handleTask((TaskRequest)inFromClient.readObject()));
+					
+					/*
+					Class<?> cls = Class.forName(task.name);
+					Object obj = cls.newInstance();
+					
+					Method method = cls.getDeclaredMethod("execute", Integer.class);
+					method.invoke(obj, 4);*/
+				}
+				
+				outToClient.close();
+				inFromClient.close();
+				socket.close();
+				
+				outToClient = null;
+				inFromClient = null;
+				socket = null;
+				task = null;
+				result = null;
+				execution_time = 0;
+				//Toast.makeText(mContext, "Client Connected: " + socket.getInetAddress().getHostAddress(), Toast.LENGTH_SHORT).show();
+				
+			}
+			//socket.close();
+			
+		} 
+		catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		} 
+		catch (ClassNotFoundException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	private Object handleTask(TaskRequest task)
+	{
+		Object result = null;
+		
+		if(task.name.equals("SUM"))
+		{
+			Log.d(TAG, "SUM!!!");
+			result = new Sum((Integer)task.parameters.get(0), (Integer)task.parameters.get(1)).execute();
+		}
+		else if(task.name.equals("BYE"))
+		{
+			Log.d(TAG, "BYE!!!");
+			isConnected = false;
+		}
+		
+		return result;
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/Task.java AndroidSource/frameworks/base/services/java/com/android/server/distribute/Task.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/distribute/Task.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/distribute/Task.java	2015-01-27 11:54:29.000000000 +0900
@@ -0,0 +1,6 @@
+package com.android.server.distribute;
+
+public interface Task<T> 
+{
+	T execute();
+}
